SetGraphicsDriver GLMax2DDriver()
Graphics 1024,512,0


ChangeDir("Fonts/")
quicky=ReadDir(CurrentDir$())

ChangeDir("../")
FontSize=14

Repeat
FontName$=NextFile(quicky)
If Upper$(Right$(FontName$,4)) =".TTF"
fontname2$=Left$(FontName$,Len(FontName$)-4)

Global Wide[256]

reallyfat=0
reallytall=0

For hd=0 To 2
Cls

fatestletter=0
fatestnumber=0
tallest=0

	hd2=hd+1
	If hd2=3 Then hd2=4
	width=256*hd2
	fin=CreatePixmap(width,128*hd2,PF_RGBA8888)
	
	ChangeDir("Fonts/")
	font=LoadImageFont(FontName$,FontSize*(hd2),0)',SMOOTHFONT)
	DebugLog font
	ChangeDir("../")
	SetImageFont font
	
	x=0
	y=0
	highest=0
	For c=32 To 255
	If y<128*hd2
		highest=c
		SetViewport x,y,16*hd2,16*hd2
		DrawText(Chr$(c),x,y)

		' Scan Size
Wide[c]=0
temp=GrabPixmap(x,y,16*hd2,16*hd2)
out=ReadPixel(temp,0,0)
For ex=0 To 15*hd2
For ey=0 To 15*hd2
	argb=ReadPixel(temp,ex,ey)
	a=((argb & $FF000000) Shr 24)
	r=((argb & $FF0000) Shr 16)
	out=argb & $00FFFFFF
	If r>0
		out=argb & $FFFFFFFF
		If ex>fatestletter Then fatestletter=ex
		If ex>fatestnumber And c>47 And c<58 Then fatestnumber=ex
		If ey>tallest Then tallest=ey
		
		If ex>reallyfat*hd2 Then reallyfat=ex/hd2
		If ey>reallytall*hd2 Then reallytall=ey/hd2
		
		If ex>Wide[c] Then Wide[c]=ex
	EndIf
	
	
	
'	If c=33 Then DebugLog Hex$(out)+":"+Hex$(argb)+":"+r
	WritePixel(fin,x+ex,y+ey,out)
Next
Next
temp=Null
GCCollect()

		x=x+16*hd2
		If x=>width Then x=0;y=y+16*hd2 
	EndIf
	Next
	
	SetViewport 0,0,1024,512

Wide[32]=fattestletter/2
For n=48 To 57
	Wide[n]=fatestnumber
Next

Cls
DrawPixmap(fin,0,0)

ChangeDir("Output/")

If hd=0 Then SavePixmapPNG fin,FontName2$+".png",3';quicky2=WriteFile(fontname2$+".dat")
If hd=1 Then SavePixmapPNG fin,FontName2$+"-hd.png",3';quicky2=WriteFile(fontname2$+"-hd.dat")
If hd=2 Then SavePixmapPNG fin,FontName2$+"-hd2.png",3';quicky2=WriteFile(fontname2$+"-hd2.dat")

'WriteByte(quicky2,fatestnumber)
'WriteByte(quicky2,fatestletter)
'WriteByte(quicky2,tallest)
'For n=32 To highest
'	WriteByte(quicky2,n)
'Next
'


ChangeDir("../")

fin=Null
GCCollect()

Flip
'WaitKey()
If KeyDown(KEY_ESCAPE) Then End
Next

quicky2=WriteFile("Output/"+fontname2$+".txt")
WriteLine(quicky2,"Font Width  : "+reallyfat)
WriteLine(quicky2,"Font Height : "+reallytall)
CloseFile quicky2

EndIf
Until FontName$=""